  implicit none
  character(len=20) :: FName,FNameOut
  character(len=40) :: LineIN
  character(len=1)  :: AutoMake="y",Skip="y",Filter="n"
  integer           :: IO,Debug,Lines=0,DataNow=0,i
  logical           :: DataRead=.false.
  real              :: lat,lon,latMAX=-999.0,lonMAX=-999.0,latMIN=999.0,lonMIN=999.0,Criteria=0.0
  print*,"===== Vis5D MapMaker Version 1.0.0.0 Released 2010 Sep.14 Copyright (C) 2010 Cypresslin"
  print*,"===== This is free software, but WITHOUT ANY WARRANTY; you are free to use, "
  print*,"===== modify and redistribute it under the terms of the GNU General Public License."
  print*,"===== Visit http://cypresslin.web.fc2.com/V5DMapMaker.html for more informations."
  print*,""
  print*,"input FileName:"
  read(*,*) FName
  print*,"Filter out small places? (y/n, It'll take some times)"
  read(*,"(a)") Filter
  if (Filter=="y".or.Filter=="Y") then
      print*,"Please specify filter criteria in degree: (format X.XXX)"
      print*,"ex: 0.01 (for 1km, 1 degree in lat/lon is about 100km)"
      do while(Criteria <= 0)
          read(*,*) Criteria
          if (Criteria <= 0) print*,"Wrong criteria, enter again:"
      enddo
  endif
  open(10,file=trim(FName),IOSTAT=IO,status="old",action="read")
  if (Filter=="y".or.Filter=="Y") then
      open(20,file=trim(FName)//"_MOD",IOSTAT=IO,status="unknown",action="write")
  endif
  if (IO /= 0) then
      print*,"Cannot open ",FName
      stop
  endif
  do while(IO == 0)
      read(10,"(a40)",IOSTAT=IO) LineIN
      Lines=Lines+1
      if(IO /=0) exit
          if (Filter=="y".or.Filter=="Y") then
              if (LGE(LineIN(1:1),"a").and.LLE(LineIN(1:1),"z").or.LGE(LineIN(1:1),"A").and.LLE(LineIN(1:1),"Z")) then ! alphabetic (Area/END)
                  if (DataRead.and.index(LineIN,"END")/=0) then
                      if (lonMAX-lonMIN < Criteria.and.latMAX-latMIN< Criteria) then
                          !ShouldSkip, minus data lines
                          Lines=Lines-DataNow-2
                      else
                          do i=1,DataNow+2 ! Go Back read again, along with data serial and END
                              BACKSPACE(10)
                          enddo
                          do i=1,DataNow+2 ! write in
                              read(10,"(a40)") LineIN
                              write(20,"(a)") trim(LineIN)
                          enddo
                      endif
                      lonMAX=-999.0
                      latMAX=-999.0
                      lonMIN=999.0
                      latMIN=999.0
                      DataRead=.false.
                  else
                      write(20,"(a)") trim(LineIN)
                  endif
                  DataNow=0
              elseif (index(LineIN, ".") > 0) then !lat/lon
                  DataRead=.true.
                  DataNow=DataNow+1  ! DataThat should be rewined
                  read(LineIN,*) lon,lat
                  if (lon.ge.lonMAX) lonMAX=lon
                  if (lat.ge.latMAX) latMAX=lat
                  if (lon.le.lonMIN) lonMIN=lon
                  if (lat.le.latMIN) latMIN=lat
              else ! White space or DataNum
                  if (LGE(LineIN(1:1),"0").and.LLE(LineIN(1:1),"9")) then ! DataNum
                      ! On hold, do nothing
                  else
                      !write(20,"(a)") trim(LineIN)
                      ! skip white spaces, so do nothing
                  endif
                  DataNow=0
              endif
          endif
  enddo
  Lines=Lines-1
  close(10)
  if (Filter=="y".or.Filter=="Y") then
      close(20)
  endif
  print*,"Scanning... Done."
  print*,"Output FileName:"
  read(*,*) FNameOut
  print*,"Auto Make & Run ? (y/n, y will remove the executable file 'makemap')"
  read(*,"(a)") AutoMake
  if (AutoMake=="y" .or. AutoMake=="Y") print*,"Removing makemap... Done."
  if (AutoMake=="y" .or. AutoMake=="Y") call system("rm ./makemap")
  print*,"Skip the First line data? (y for non-QC maproom data)? (y/n)"
  read(*,"(a)") Skip
  print*,"Debug Mode? (0 for no, 1 for yes, 2 for input/output details, 3 for Line-by-Line details)"
  read(*,"(i1)") Debug


  open(20,file="makemap.c")
  call MakeMapPartI()
  write(20,*) ""
  write(20,*) "//Genereated by Vis5D MapMaker Ver 1.0.0.0 (Author: Cypresslin)"
  write(20,*) "//Visit http://cypresslin.web.fc2.com/V5DMapMaker.html for more informations."
  write(20,*) "#define TRUE 1"
  write(20,*) "#define FALSE 0"
  write(20,*) " FILE *fin;"
  write(20,*) " float lon,lat;"
  write(20,*) " int EOD=FALSE, BOD=FALSE; //End of Data, Begin of Data"
  if (Skip == "y".or. Skip=="Y") write(20,*) " int FLine=FALSE; // First Line"
  if (Debug >= 1 ) write(20,*) " int k=0;"
  write(20,*) " char LineIN[40],*clon,*clat;"
  if (Filter=="y".or.Filter=="Y") then
      write(20,*) ' fin=fopen("'//trim(FName)//'_MOD","r");'
  else
      write(20,*) ' fin=fopen("'//trim(FName)//'","r");'
  endif
  write(20,*) ' printf("MapMaker Started\\n");'
  write(20,*) ' while(!feof(fin)){'
  write(20,*) '     fgets(LineIN,40,fin);'
  if (Debug >= 1 ) write(20,*) '     k=k+1;'
  if (Debug == 1 ) write(20,*) '     printf("Current line: %d \\n",k);'
  if (Debug >= 2 ) write(20,*) '     printf("Read: %s",k,LineIN);'
  write(20,*) '     if (strstr(LineIN,"END") != NULL && EOD==FALSE){'
  write(20,*) '         end_line();'
  write(20,*) '         EOD=TRUE;'
  write(20,*) '         BOD=TRUE;'
  if (Skip == "y".or. Skip=="Y") write(20,*) '         FLine=TRUE;'
  if (Debug == 3 ) write(20,*) '     printf("symbol END found at line %d,call end_line()\\n" ,k);'
  write(20,*) '     }'
  write(20,*) '     else if(isalpha(LineIN[0]) != 0 ){  //Not End but is alphabetic (should be Area Name)'
  write(20,*) '         BOD=TRUE;'
  if (Skip == "y".or. Skip=="Y") write(20,*) '         FLine=TRUE;'
  if (Debug == 3 ) write(20,*) '         printf("Second END symbol or Area name found at line %d, do nothing\\n" ,k);'
  write(20,*) '     }'
  write(20,*) '     else if(atof(LineIN) == 0.0){   //Not End also Not Numeric (should be whitespace)'
  if (Debug == 3 ) write(20,*) '         printf("WhiteSpace found at line %d, do nothing\\n",k);'
  write(20,*) '     }'
  write(20,*) "     else{ //It's numeric"
  write(20,*) "         if(BOD){  //Begin of data, so this line should be data num.}"
  if (Debug >= 2)write(20,*) '             printf("Data Serial Number found at line %d, do nothing\\n",k);'
  write(20,*) '             BOD=FALSE;'
  write(20,*) '         }'
  if (Skip == "y".or. Skip=="Y") write(20,*) '         else if(FLine) {  // First Line'
  if (Skip == "y".or. Skip=="Y") then
      if(Debug ==3) write(20,*) '             printf("First Line Data skipped at line %d\\n",k);'
  endif
  if (Skip == "y".or. Skip=="Y") write(20,*) '             FLine=FALSE;'
  if (Skip == "y".or. Skip=="Y") write(20,*) '         }'
  write(20,*) '         else{'
  write(20,*) '             clon = strtok (LineIN," ");'
  write(20,*) '             clat = strtok (NULL," ");'
  write(20,*) '             lon=atof(clon);'
  write(20,*) '             lat=atof(clat);'
  write(20,*) '             vertex(lat,-lon);'
  write(20,*) '             EOD=FALSE;'
  if (Debug >= 2) write(20,*) '             printf("Convert: %f %f at line %d\\n",lon,lat,k);'
  write(20,*) '         }'
  write(20,*) '     }'
  write(20,*) ' }'
  write(20,*) ' done("'//trim(FNameOut)//'");'
  write(20,*) ' fclose(fin);'
  write(20,*) ' printf("Map file writing CMPL\\n");'
  write(20,*) ' exit(0);'
  call MakeMapPartII(Lines)
  close(20)
  if (AutoMake=="y" .or. AutoMake=="Y") call system("make;./makemap")
  stop
  end
       
       
  subroutine MakeMapPartI()
  implicit none
  write(20,*) "/* makemap.c */"
  write(20,*) "/*"
  write(20,*) " * Vis5D system for visualizing five dimensional gridded data sets."
  write(20,*) " * Copyright (C) 1990 - 2000 Bill Hibbard, Johan Kellum, Brian Paul,"
  write(20,*) " * Dave Santek, and Andre Battaiola."
  write(20,*) ""
  write(20,*) " * This program is free software; you can redistribute it and/or modify"
  write(20,*) " * it under the terms of the GNU General Public License as published by"
  write(20,*) " * the Free Software Foundation; either version 2 of the License, or"
  write(20,*) " * (at your option) any later version."
  write(20,*) ""
  write(20,*) " * As a special exception to the terms of the GNU General Public"
  write(20,*) " * License, you are permitted to link Vis5D with (and distribute the"
  write(20,*) " * resulting source and executables) the LUI library (copyright by"
  write(20,*) " * Stellar Computer Inc. and licensed for distribution with Vis5D),"
  write(20,*) " * the McIDAS library, and/or the NetCDF library, where those"
  write(20,*) " * libraries are governed by the terms of their own licenses."
  write(20,*) ""
  write(20,*) " * This program is distributed in the hope that it will be useful,"
  write(20,*) " * but WITHOUT ANY WARRANTY; without even the implied warranty of"
  write(20,*) " * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the"
  write(20,*) " * GNU General Public License for more details."
  write(20,*) ""
  write(20,*) " * You should have received a copy of the GNU General Public License"
  write(20,*) " * along with this program; if not, write to the Free Software"
  write(20,*) " * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA"
  write(20,*) " * "
  write(20,*) " */"
  write(20,*) ""
  write(20,*) '#include "../config.h"'
  write(20,*) ""
  write(20,*) "/*"
  write(20,*) " * Utility program to make your own map outline files."
  write(20,*) " *"
  write(20,*) " * A map outline file consists of a number of polylines.  A polyline"
  write(20,*) " * is a sequence of connected line segments.  The end points (vertices)"
  write(20,*) " * of the lines are defined in degrees of latitude and longitude."
  write(20,*) " *"
  write(20,*) " * Compile with:   make -f makemap.m"
  write(20,*) " * "
  write(20,*) " */"  
  write(20,*) ""
  write(20,*) "#include <stdio.h>"
  write(20,*) "#ifdef HAVE_SYS_TYPES_H"
  write(20,*) "#  include <sys/types.h>"
  write(20,*) "#endif"
  write(20,*) "#ifdef HAVE_SYS_STAT_H"
  write(20,*) "#  include <sys/stat.h>"
  write(20,*) "#endif"
  write(20,*) "#ifdef HAVE_FCNTL_H"
  write(20,*) "#  include <fcntl.h>"
  write(20,*) "#endif"
  write(20,*) ""
  write(20,*) "#include <binio.h>"
  write(20,*) "#include <string.h>"
  write(20,*) "#include <stdlib.h>"
  write(20,*) "#include <ctype.h>"
  write(20,"(a18)") "main( argc, argv )"
  write(20,"(a9)") "int argc;"
  write(20,"(a13)") "char *argv[];"
  write(20,"(a1)") "{"
  write(20,*) "   /****** Replace this example code with your own! *****/"
  write(20,*) '   /* this example writes a mapfile which spells out "ABC" like this:'
  write(20,*) ""
  write(20,*) "                                               |"
  write(20,*) "                                               |    L"
  write(20,*) "         2*       7*-*8      12*-----*11       +50  a"
  write(20,*) "         / \\       |  \\        |               |    t"
  write(20,*) "        /   \\      |   \\       |               |    i"
  write(20,*) "      1*-----*3   6*----*9     |               +35  t"
  write(20,*) "       |     |     |    |      |               |    u"
  write(20,*) "       |     |     |    |      |               |    d"
  write(20,*) "      0*     *4   5*----*10  13*-----*14       +20  e"
  write(20,*) "                                               |"
  write(20,*) "  -----+-----+-----+----+------+-----+---------+---"
  write(20,*) "      130   120   110  100     90    80        |0"
  write(20,*) "                    Longitude                  |"
  write(20,*) ""
  write(20,*) "   The asterisks are the vertices.  The polylines are defined by:"
  write(20,*) "      0,1,2,3,4"
  write(20,*) "      1,3"
  write(20,*) "      5,6,7,8,9,10,5"
  write(20,*) "      6,9"
  write(20,*) "      11,12,13,14"
  write(20,*) ""
  write(20,*) "   Below is the code to make this map.  All you have to do is call"
  write(20,*) "   these functions:"
  write(20,*) ""
  write(20,*) "       vertex( lat, lon )   - to specify the next vertex in lat/lon"
  write(20,*) "       end_line()           - to signal the end of a polyline"
  write(20,*) "       done( filename )     - to write the named map file"
  write(20,*) ""
  write(20,*) "   If you use this example unchanged then you can view the map with:"
  write(20,*) "       vis5d LAMPS.v5d -map util/OUTLABC"
  write(20,*) "   */"
  write(20,*) ""
  write(20,*) "/* Custom Map */"
  return
  end

  subroutine MakeMapPartII(Lines)
  implicit none
  integer,intent(in) :: Lines
  write(20,*) "}"
  write(20,*) ""
  write(20,*) ""
  write(20,*) "/**********************************************************************/"
  write(20,*) "/***        No changes beyond this point should be necessary.       ***/"
  write(20,*) "/**********************************************************************/"
  write(20,*) ""
  write(20,*) "struct polyline {"
  write(20,*) "        int        minlat;"
  write(20,*) "        int        maxlat;"
  write(20,*) "        int        minlon;"
  write(20,*) "        int        maxlon;"
  write(20,*) "        int        start;"
  write(20,*) "        int        len;"
  write(20,*) "};"
  write(20,*) ""
  write(20,*) "#define MAXLINES ",Lines
  write(20,*) "struct polyline MapLine[MAXLINES];"
  write(20,*) "int NumLines = 0;"
  write(20,*) ""
  write(20,*) "struct vertex {"
  write(20,*) "        int       lat, lon;"
  write(20,*) "};"
  write(20,*) ""
  write(20,*) "#define MAXVERTS ",Lines
  write(20,*) "struct vertex VertexList[MAXVERTS];"
  write(20,*) "int NumVertices = 0;"
  write(20,*) ""
  write(20,*) "initialize()"
  write(20,*) "{"
  write(20,*) "   NumLines = NumVertices = 0;"
  write(20,*) "   MapLine[0].minlat =  10000000;"
  write(20,*) "   MapLine[0].maxlat = -10000000;"
  write(20,*) "   MapLine[0].minlon =  10000000;"
  write(20,*) "   MapLine[0].maxlon = -10000000;"
  write(20,*) "   MapLine[0].start = 0;"
  write(20,*) "   MapLine[0].len = 0;"
  write(20,*) "}"
  write(20,*) ""
  write(20,*) "vertex( lat, lon )"
  write(20,*) "float lat, lon;"
  write(20,*) "{"
  write(20,*) "   static int init_flag = 1;"
  write(20,*) "   if (init_flag) {"
  write(20,*) "      initialize();"
  write(20,*) "      init_flag = 0;"
  write(20,*) "   }"
  write(20,*) ""
  write(20,*) "   if (NumVertices>=MAXVERTS) {"
  write(20,*) '      printf("Out of space for map vertices!\\n");'
  write(20,*) "      exit(1);"
  write(20,*) "   }"
  write(20,*) "   else {"
  write(20,*) "      int ilat = (int) (lat * 10000.0);"
  write(20,*) "      int ilon = (int) (lon * 10000.0);"
  write(20,*) "      VertexList[NumVertices].lat = ilat;"
  write(20,*) "      VertexList[NumVertices].lon = ilon;"
  write(20,*) "      NumVertices++;"
  write(20,*) "      MapLine[NumLines].len++;"
  write(20,*) "      if (ilat > MapLine[NumLines].maxlat)   MapLine[NumLines].maxlat = ilat;"
  write(20,*) "      if (ilat < MapLine[NumLines].minlat)   MapLine[NumLines].minlat = ilat;"
  write(20,*) "      if (ilon > MapLine[NumLines].maxlon)   MapLine[NumLines].maxlon = ilon;"
  write(20,*) "      if (ilon < MapLine[NumLines].minlon)   MapLine[NumLines].minlon = ilon;"
  write(20,*) "   }"
  write(20,*) "}"
  write(20,*) ""
  write(20,*) "end_line()"
  write(20,*) "{"
  write(20,*) "   if (NumVertices==0 || MapLine[NumLines].len==0) {"
  write(20,*) '      printf("Error:  must call vertex() before end_line()!\\n");'
  write(20,*) "      exit(1);"
  write(20,*) "   }"
  write(20,*) ""
  write(20,*) "   MapLine[NumLines].len *= 2;"
  write(20,*) "   NumLines++;"
  write(20,*) "   if (NumLines>=MAXLINES) {"
  write(20,*) '      printf("Error: out of space for lines!\\n");'
  write(20,*) "      exit(1);"
  write(20,*) "   }"
  write(20,*) "   MapLine[NumLines].minlat =  10000000;"
  write(20,*) "   MapLine[NumLines].maxlat = -10000000;"
  write(20,*) "   MapLine[NumLines].minlon =  10000000;"
  write(20,*) "   MapLine[NumLines].maxlon = -10000000;"
  write(20,*) "   MapLine[NumLines].start = NumVertices;"
  write(20,*) "   MapLine[NumLines].len = 0;"
  write(20,*) "}"
  write(20,*) ""
  write(20,*) "done( filename )"
  write(20,*) "char *filename;"
  write(20,*) ""
  write(20,*) "{"
  write(20,*) "   int f;"
  write(20,*) "   mode_t mask;"
  write(20,*) "   int i;"
  write(20,*) ""
  write(20,*) "   /* Convert MapLine[].start values from index into VertexList to"
  write(20,*) "    * absolute file positions (in 4-byte units)."
  write(20,*) "    */"
  write(20,*) "   for (i=0;i<NumLines;i++) {"
  write(20,*) "      int index, pos;"
  write(20,*) "      index = MapLine[i].start;"
  write(20,*) "      pos = 6*NumLines + index*2 + 1;"
  write(20,*) "      MapLine[i].start = pos;"
  write(20,*) "   }"
  write(20,*) ""
  write(20,*) "   mask = 0666;"
  write(20,*) "   f = open( filename, O_WRONLY | O_CREAT | O_TRUNC, mask );"
  write(20,*) "   if (f<0) {"
  write(20,*) '      printf("Error:  unable to open %s for writing\\n", filename );'
  write(20,*) "      exit(0);"
  write(20,*) "   }"
  write(20,*) ""
  write(20,*) "   write_int4( f, NumLines );"
  write(20,*) ""
  write(20,*) "   if (write_int4_array( f, (int *) MapLine, 6*NumLines ) < 6*NumLines) {"
  write(20,*) '      printf("Error:  bad file write (disk full?)\\n");'
  write(20,*) "      exit(0);"
  write(20,*) "   }"
  write(20,*) ""
  write(20,*) "   if (write_int4_array( f, (int *) VertexList, 2*NumVertices ) < 2*NumVertices) {"
  write(20,*) '      printf("Error:  bad file write (disk full?)\\n");'
  write(20,*) "      exit(0);"
  write(20,*) "   }"
  write(20,*) ""
  write(20,*) "   close( f );"
  write(20,*) "}"
  return
  end
  
